unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, _Base, ExtCtrls, StdCtrls, Buttons, Menus, ComCtrls, IniFiles;

type
  TMainForm = class(T_BaseForm)
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuMisc: TMenuItem;
    MenuFromFile: TMenuItem;
    MenuFromClipBoard: TMenuItem;
    N1: TMenuItem;
    MenuExit: TMenuItem;
    MenuAbout: TMenuItem;
    MenuThisFolder: TMenuItem;
    MenuStayOnTop: TMenuItem;
    N3: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    oFile1: TMenuItem;
    oClipBoard1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    MenuUsage: TMenuItem;
    MenuTool: TMenuItem;
    MenuCutNullLine: TMenuItem;
    Memo2: TMemo;
    MenuEditTemplate: TMenuItem;
    MenuEditPreString: TMenuItem;
    MenuEditPostString: TMenuItem;
    N2: TMenuItem;
    procedure MenuFromFileClick(Sender: TObject);
    procedure MenuFromClipBoardClick(Sender: TObject);
    procedure MenuToFileClick(Sender: TObject);
    procedure MenuToClipBoardClick(Sender: TObject);
    procedure MenuThisFolderClick(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuStayOnTopClick(Sender: TObject);
    procedure MenuUsageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuCutNullLineClick(Sender: TObject);
    procedure MenuEditTemplateClick(Sender: TObject);
    procedure MenuEditPostStringClick(Sender: TObject);
    procedure MenuEditPreStringClick(Sender: TObject);
  private
    IniFile     : TIniFile;
    LinkString  : string;
    PreString   : string;
    PostString  : string;

    procedure   Convert();

    procedure   LoadFromFile(AFileName: string);
    procedure   LoadFromClipborad();

    procedure   SaveToFile(AFileName: string);
    procedure   SaveToClipborad();
  public

  end;

var
  MainForm: TMainForm;

implementation

uses
    ClipBrd, iFiles, Info;

{$R *.dfm}

//  ---------------------------------------------------------------------------

//  ϊ
procedure   TMainForm.Convert();
var
    i: integer;
    Line1, Line2, Line: string;
begin
    Memo2.Lines.Clear;
    for i := 0 to (Memo1.Lines.Count - 1) div 2 do
    begin
        Line1 := Memo1.Lines[2 * i];
        Line2 := Memo1.Lines[2 * i + 1];
        Line := LinkString;
        Line := StringReplace(Line, '#STR#', Line1, [rfReplaceAll]);
        Line := StringReplace(Line, '#URL#', Line2, [rfReplaceAll]);
        Memo2.Lines.Add(Line);       
    end;
    if (PreString <> '') then Memo2.Lines.Insert(0, PreString);
    if (PostString <> '') then Memo2.Lines.Add(PostString);
end;

//  t@CǍ
procedure   TMainForm.LoadFromFile(AFileName: string);
begin
    Memo1.Lines.LoadFromFile(AFileName);
    Convert();
end;

//  Nbv{[hǍ
procedure   TMainForm.LoadFromClipborad();
begin
    if Clipboard.HasFormat(CF_TEXT) then
    begin
        Memo1.Lines.Text := Clipboard.AsText;
        Convert();
    end;
end;

//  t@C֏o
procedure   TMainForm.SaveToFile(AFileName: string);
begin
    Memo2.Lines.SaveToFile(AFileName);
end;

//  Nbv{[h֏o
procedure   TMainForm.SaveToClipborad();
begin
    Clipboard.AsText := Memo2.Lines.Text;
end;

//  ---------------------------------------------------------------------------

//  t@CǍ
procedure TMainForm.MenuFromFileClick(Sender: TObject);
begin
    if OpenDialog1.Execute then
    begin
        LoadFromFile(OpenDialog1.FileName);
    end;
end;

//  Nbv{[hǍ
procedure TMainForm.MenuFromClipBoardClick(Sender: TObject);
begin
    LoadFromClipborad();
end;

//  I
procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close;
end;

//  ---------------------------------------------------------------------------

procedure TMainForm.MenuCutNullLineClick(Sender: TObject);
var
    i: integer;
begin
    for i := Memo1.Lines.Count - 1 downto 0 do
    begin
        if Trim(Memo1.Lines[i]) = '' then Memo1.Lines.Delete(i);
    end;
    Convert();
end;

procedure TMainForm.MenuEditPreStringClick(Sender: TObject);
begin
    PreString := InputBox('EditTemplate', 'PreString', PreString);
    Convert();
end;

procedure TMainForm.MenuEditTemplateClick(Sender: TObject);
begin
    LinkString := InputBox('EditTemplate', 'LinkString', LinkString);
    Convert();
end;

procedure TMainForm.MenuEditPostStringClick(Sender: TObject);
begin
    PostString := InputBox('EditTemplate', 'PostString', PostString);
    Convert();
end;

//  ---------------------------------------------------------------------------

//  ϊ:t@Cɏo
procedure TMainForm.MenuToFileClick(Sender: TObject);
begin
    if SaveDialog1.Execute then
    begin
        SaveToFile(SaveDialog1.FileName);
    end;
end;

//  ϊ:Nbv{[hɏo
procedure TMainForm.MenuToClipBoardClick(Sender: TObject);
begin
    SaveToClipborad();
end;

//  ---------------------------------------------------------------------------

//  Vӂێ
procedure TMainForm.MenuUsageClick(Sender: TObject);
var
    Msg: string;
begin
    Msg :=
        '1sڂ2s/3sڂ4s/...Zbgň܂B'#13#10 +
        '  1sڂN^Oŋݍޕ'#13#10 +
        '  2sڂN^Õ^[QbgURL'#13#10 +
        'Ƃ܂B3sڈȍ~lɈ܂B'#13#10 +
    '';
    ShowMessage(Msg);
end;

//  Vӂێ
procedure TMainForm.MenuStayOnTopClick(Sender: TObject);
begin
    TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
    if (TMenuItem(Sender).Checked) then
    begin
        Self.FormStyle := fsStayOnTop;
    end
    else
    begin
        Self.FormStyle := fsNormal;
    end;
end;

//  ̃vÕtH_
procedure TMainForm.MenuThisFolderClick(Sender: TObject);
begin
    SimpleShellExecute(AppDirPath);
end;

//  
procedure TMainForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//  ---------------------------------------------------------------------------

const
    LINK_STR_DEFAULT  = '<li><a target="link" href="#URL#">#STR#</a>';
    PRE_STR_DEFAULT   = '<ul>';
    POST_STR_DEFAULT  = '</ul>';

procedure TMainForm.FormCreate(Sender: TObject);
begin
  inherited;
    IniFile := TIniFile.Create(ChangeFileExt(AppExePath, '.ini'));
    LinkString := IniFile.ReadString('CONF', 'LINK_STRING', LINK_STR_DEFAULT);
    PreString := IniFile.ReadString('CONF', 'PRE_STRING', PRE_STR_DEFAULT);
    PostString := IniFile.ReadString('CONF', 'POST_STRING', POST_STR_DEFAULT);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
    IniFile.WriteString('CONF', 'STRING', LinkString);
    IniFile.WriteString('CONF', 'PRE_STRING', PreString);
    IniFile.WriteString('CONF', 'POST_STRING', PostString);
    IniFile.Free;
  inherited;
end;

end.

